## stopt 5.12+dfsg

=== CMakeLists.txt ===
# vim: set sw=2 ts=2 sts=2:
CMAKE_MINIMUM_REQUIRED(VERSION 3.18)

set(VERSION_REGEX "#define STOPT_VERSION")
file(STRINGS "${CMAKE_CURRENT_SOURCE_DIR}/StOpt/core/utils/version.h" VERSION_STRING REGEX ${VERSION_REGEX})
string(REGEX REPLACE ${VERSION_REGEX} "" VERSION_STRING "${VERSION_STRING}")
string(REGEX REPLACE " *\"" "" VERSION_STRING "${VERSION_STRING}")
MESSAGE(STATUS "StOpt version : ${VERSION_STRING}")
PROJECT(LIBRARY_STOPT  VERSION ${VERSION_STRING} LANGUAGES CXX)
SET(CMAKE_MODULE_PATH "${LIBRARY_STOPT_SOURCE_DIR}/CMakeModules;${CMAKE_MODULE_PATH}")
SET(CMAKE_MACOSX_RPATH "${CMAKE_INSTALL_PREFIX}/lib")

IF(NOT CMAKE_BUILD_TYPE)
  message(STATUS "Setting build type to 'Release' as none was specified.")
  SET(CMAKE_BUILD_TYPE Release CACHE STRING "Choose the type of build." FORCE)
ENDIF(NOT CMAKE_BUILD_TYPE)

# option for PYTHON
OPTION(BUILD_PYTHON "Build python bindings" ON)

# option for MPI
OPTION(BUILD_MPI "Build MPI test" ON)

# option for SDDP 
OPTION(BUILD_SDDP "Build SDDP test" OFF)

# option for DP for Cuts
OPTION(BUILD_DPCUTS "Build DP CUTS test" OFF)

OPTION(BUILD_CPACK "Build for CPACK" OFF)

# option for branching
OPTION(BUILD_BRANCHING "Build Branching test" OFF)
IF (BUILD_BRANCHING)
  IF (NOT BUILD_MPI)
    MESSAGE(FATAL_ERROR "MPI should be on for Branching")
  ENDIF()
  FIND_PACKAGE(Trng4 REQUIRED)
  INCLUDE_DIRECTORIES(SYSTEM ${TRNG4_INCLUDE_DIRS})
ENDIF()

#option for building test
OPTION(BUILD_TEST "Build test " ON)

#option for testing long test cases
OPTION(BUILD_LONG_TEST "Add long tests to the testing module" OFF)
IF(BUILD_LONG_TEST)
  ADD_DEFINITIONS(-DUSE_LONG_TEST)
ENDIF(BUILD_LONG_TEST)

# Boost
ADD_DEFINITIONS(-DBOOST_ALL_DYN_LINK)
IF(BUILD_TEST)
  FIND_PACKAGE(Boost COMPONENTS unit_test_framework  system  timer chrono log thread  REQUIRED)
ENDIF()
MESSAGE(STATUS "Boost unit_test_framework: ${Boost_UNIT_TEST_FRAMEWORK_LIBRARY}")
FIND_PACKAGE(Boost COMPONENTS  random REQUIRED)
find_package (Threads REQUIRED)
FIND_PACKAGE(Boost COMPONENTS serialization REQUIRED)
MESSAGE(STATUS "Boost serialization : ${Boost_SERIALIZATION_LIBRARY}")
INCLUDE_DIRECTORIES(SYSTEM ${Boost_INCLUDE_DIRS})
IF(BUILD_MPI)
  FIND_PACKAGE(MPI)
  IF(NOT MPI_CXX_FOUND)
    SET(BUILD_MPI OFF)
  ELSE()
    FIND_PACKAGE(Boost COMPONENTS mpi )
    IF(Boost_MPI_FOUND)
      MESSAGE(STATUS "Boost mpi: ${Boost_MPI_LIBRARY}")
    ENDIF(Boost_MPI_FOUND)
    IF(Boost_MPI_FOUND)
      INCLUDE_DIRECTORIES(SYSTEM ${MPI_CXX_INCLUDE_PATH})
      ADD_DEFINITIONS(-DUSE_MPI)
    ELSE()
      MESSAGE(STATUS "Boost modules mpi  not found. Set BUILD_MPI=OFF")
      SET(BUILD_MPI OFF)
    ENDIF(Boost_MPI_FOUND)
  ENDIF(NOT MPI_CXX_FOUND)
ENDIF(BUILD_MPI)

IF (WIN32)
  #zlib
  FIND_PACKAGE(ZLIB REQUIRED)
 
  #bzip2
  FIND_PACKAGE(BZip2 REQUIRED)
ENDIF(WIN32)

#Eigen
FIND_PACKAGE(Eigen3 REQUIRED)
INCLUDE_DIRECTORIES(SYSTEM ${EIGEN3_INCLUDE_DIR})
# Add some extra delete[] and new[] operatros needed by boost to Eigen::PlainObjectBase
IF (APPLE)
  ADD_DEFINITIONS(-DEIGEN_PLAINOBJECTBASE_PLUGIN="StOpt/core/utils/eigenMemory.h")
ENDIF(APPLE)


INCLUDE_DIRECTORIES(${PROJECT_SOURCE_DIR})

IF (NOT MSVC)
 # Detect if the compiler supports C+11
 INCLUDE(CheckCXXCompilerFlag)
 CHECK_CXX_COMPILER_FLAG("-std=c++14" COMPILER_SUPPORTS_CXX14)
 CHECK_CXX_COMPILER_FLAG("-std=c++11" COMPILER_SUPPORTS_CXX11)
 CHECK_CXX_COMPILER_FLAG("-std=c++0x" COMPILER_SUPPORTS_CXX0X)
 IF(COMPILER_SUPPORTS_CXX14)
  SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++14")
 ELSEIF(COMPILER_SUPPORTS_CXX11)
  SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11")
 ELSEIF(COMPILER_SUPPORTS_CXX0X)
  SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++0x")
 ELSE()
  MESSAGE(STATUS "The compiler ${CMAKE_CXX_COMPILER} has no C++11 support. Please use a different C++ compiler.")
 ENDIF()
 SET(PTHREAD_LIBRARY "-lpthread")
ELSE()
  IF(MSVC_VERSION LESS 1800)
    MESSAGE(STATUS "The compiler ${CMAKE_CXX_COMPILER} has no decent C++11 support. Please use a different C++ compiler.")
  ENDIF()
  ADD_COMPILE_OPTIONS(/bigobj)
ENDIF(NOT MSVC)

# Update flags according to the compiler
IF (${CMAKE_CXX_COMPILER_ID} MATCHES Clang)
   IF (APPLE)
     SET(CLANG_SANITIZE_FLAGS "")
  ELSE(APPLE)
     #SET(CLANG_SANITIZE_FLAGS " -fsanitize=undefined-trap,memory -fsanitize-memory-track-origins  -fno-omit-frame-pointer ")
     #SET(CLANG_SANITIZE_FLAGS " -fsanitize=undefined-trap  -fno-omit-frame-pointer ")
     SET(CLANG_SANITIZE_FLAGS "")
  ENDIF(APPLE)
  SET(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG}  -g -O0 ${CLANG_SANITIZE_FLAGS}")
  SET(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} -fPIC -O3 -DNDEBUG  -DBOOST_DISABLE_ASSERTS")
  SET(CMAKE_CXX_FLAGS_RELWITHDEBINFO "${CMAKE_CXX_FLAGS_RELWITHDEBINFO} -fPIC -O2 -DNDEBUG -g  -DBOOST_DISABLE_ASSERTS")
  SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fPIC -Wall -Wextra -Wfloat-equal -Wno-system-headers ")
ELSEIF (${CMAKE_CXX_COMPILER_ID} MATCHES GNU)
  IF (APPLE)
    SET(GCC_SANITIZE_FLAGS "")
  ELSE(APPLE)
    SET(GCC_SANITIZE_FLAGS "")
  ENDIF(APPLE)
  SET(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG}  -g -O0 ")
  SET(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} -O3 -DNDEBUG  -DBOOST_DISABLE_ASSERTS")
  SET(CMAKE_CXX_FLAGS_RELWITHDEBINFO "${CMAKE_CXX_FLAGS_RELWITHDEBINFO} -O2 -DNDEBUG  -DBOOST_DISABLE_ASSERTS")
  SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -Wextra -Wno-long-long -Winit-self -Wfloat-equal -Wsign-compare -pedantic -funroll-all-loops -ffast-math -fno-strict-aliasing -ftree-vectorize  -fPIC")
ELSEIF(${CMAKE_CXX_COMPILER_ID} MATCHES Intel)
  SET(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -fpic -O1 -g -ftrapuv")
  SET(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} -fpic -O3 -DNDEBUG  -DBOOST_DISABLE_ASSERTS")
  SET(CMAKE_CXX_FLAGS_RELWITHDEBINFO "${CMAKE_CXX_FLAGS_RELWITHDEBINFO} -fpic -O2 -DNDEBUG  -DBOOST_DISABLE_ASSERTS")
ENDIF()

# Find OpenMP
FIND_PACKAGE(OpenMP)


# SERIALIZATION WITH RANDOM ACCESS
ADD_SUBDIRECTORY(geners-1.11.0)
SET(GENERS_LIB  geners)
INCLUDE_DIRECTORIES(${PROJECT_SOURCE_DIR}/geners-1.11.0)


# Compile library for C++
INCLUDE_DIRECTORIES(SYSTEM ${PROJECT_SOURCE_DIR} ${Boost_INCLUDE_DIRS})
SET(SOURCE_DIR_LIB1 ${PROJECT_SOURCE_DIR}/StOpt/regression)
SET(SOURCE_DIR_LIB2 ${PROJECT_SOURCE_DIR}/StOpt/core/utils)
SET(SOURCE_DIR_LIB3 ${PROJECT_SOURCE_DIR}/StOpt/sddp)
SET(SOURCE_DIR_LIB4 ${PROJECT_SOURCE_DIR}/StOpt/core/sparse)
SET(SOURCE_DIR_LIB5 ${PROJECT_SOURCE_DIR}/StOpt/core/grids)
SET(SOURCE_DIR_LIB6 ${PROJECT_SOURCE_DIR}/StOpt/semilagrangien)
SET(SOURCE_DIR_LIB7 ${PROJECT_SOURCE_DIR}/StOpt/dp)
SET(SOURCE_DIR_LIB8 ${PROJECT_SOURCE_DIR}/StOpt/core/parallelism)
SET(SOURCE_DIR_LIB9 ${PROJECT_SOURCE_DIR}/StOpt/tree)
SET(SOURCE_DIR_LIB10 ${PROJECT_SOURCE_DIR}/StOpt/cdf)
FILE(GLOB SOURCE  ${SOURCE_DIR_LIB1}/*.cpp ${SOURCE_DIR_LIB2}/*.cpp  ${SOURCE_DIR_LIB3}/*.cpp  ${SOURCE_DIR_LIB4}/*.cpp   ${SOURCE_DIR_LIB5}/*.cpp  ${SOURCE_DIR_LIB6}/*.cpp ${SOURCE_DIR_LIB7}/*.cpp  ${SOURCE_DIR_LIB8}/*.cpp ${SOURCE_DIR_LIB9}/*.cpp ${SOURCE_DIR_LIB10}/*.cpp  )
IF (WIN32)
  SET(SUFF "/Release")
  SET(EXTENSION ".exe")
  ADD_LIBRARY(StOpt STATIC ${SOURCE})
ELSE()
   ADD_LIBRARY(StOpt SHARED ${SOURCE})
ENDIF()
IF(BUILD_MPI)
  TARGET_LINK_LIBRARIES(StOpt ${MPI_CXX_LIBRARIES} ${MPI_C_LIBRARIES}    ${Boost_CHRONO_LIBRARY}  ${Boost_SYSTEM_LIBRARY} ${Boost_TIMER_LIBRARY}  ${Boost_MPI_LIBRARY}  ${Boost_SERIALIZATION_LIBRARY} ${GENERS_LIB} ${Boost_RANDOM_LIBRARY}  ${Boost_LOG_LIBRARY}  ${BZIP2_LIBRARIES}  ${ZLIB_LIBRARIES})
ELSE()
  TARGET_LINK_LIBRARIES(StOpt     ${Boost_CHRONO_LIBRARY}  ${Boost_SYSTEM_LIBRARY} ${Boost_TIMER_LIBRARY}  ${Boost_SERIALIZATION_LIBRARY} ${GENERS_LIB} ${Boost_RANDOM_LIBRARY} ${Boost_LOG_LIBRARY} ${BZIP2_LIBRARIES}  ${ZLIB_LIBRARIES} )
ENDIF()
IF(OPENMP_CXX_FOUND)
   TARGET_LINK_LIBRARIES(StOpt OpenMP::OpenMP_CXX)
ENDIF(OPENMP_CXX_FOUND)
SET (STOPT_LIB StOpt)
#install lib
INSTALL(TARGETS StOpt COMPONENT libraries DESTINATION "lib")
# install headers
INSTALL(DIRECTORY StOpt
    COMPONENT headers
    DESTINATION "include"
    FILES_MATCHING
    PATTERN "*.h"
    ${INSTALL_PERMISSIONS_SRC}
  )


INSTALL(DIRECTORY doc
    DESTINATION "doc"
    FILES_MATCHING
    PATTERN "*.pdf"
    ${INSTALL_PERMISSIONS_SRC}
    )

IF(BUILD_PYTHON)
    
  # Python
  FIND_PACKAGE(Python REQUIRED COMPONENTS Interpreter Development NumPy)
  INCLUDE_DIRECTORIES(SYSTEM ${Python_INCLUDE_DIRS})
  MESSAGE(STATUS "Python: ${Python_INCLUDE_DIRS}")

  # find pybind
  find_package(PyBind11 REQUIRED)

  # Numpy
  INCLUDE_DIRECTORIES(SYSTEM ${Python3_NumPy_INCLUDE_DIRS})
  SET(SOURCE_PYTHON ${PROJECT_SOURCE_DIR}/StOpt/python)
  IF(CMAKE_SYSTEM_NAME MATCHES "Windows")
    SET(PYTHON_SUFFIX ".pyd")
  ELSEIF(UNIX)
    # Python modules must end .so under Mac 
    SET(PYTHON_SUFFIX ".so")
  ENDIF()
  
  IF (APPLE)

      ADD_LIBRARY(StOptGrids  SHARED  ${SOURCE_PYTHON}/Pybind11StOptGrids.cpp)
      TARGET_LINK_LIBRARIES(StOptGrids  ${STOPT_LIB}   ${GENERS_LIB} ${Boost_SERIALIZATION_LIBRARY}   ${Boost_MPI_LIBRARY} )
      SET_TARGET_PROPERTIES(StOptGrids  PROPERTIES  PREFIX "" SUFFIX ${PYTHON_SUFFIX}  COMPILE_DEFINITIONS  "PYTHONMODULE;NPY_NO_DEPRECATED_API=NPY_1_7_API_VERSION" LINK_FLAGS "-undefined dynamic_lookup")

      ADD_LIBRARY(StOptReg  SHARED  ${SOURCE_PYTHON}/Pybind11StOptReg.cpp)
      TARGET_LINK_LIBRARIES(StOptReg  ${STOPT_LIB}   ${GENERS_LIB} ${Boost_SERIALIZATION_LIBRARY}   ${Boost_MPI_LIBRARY} )
      SET_TARGET_PROPERTIES(StOptReg  PROPERTIES  PREFIX "" SUFFIX ${PYTHON_SUFFIX}  COMPILE_DEFINITIONS  "PYTHONMODULE;NPY_NO_DEPRECATED_API=NPY_1_7_API_VERSION"  LINK_FLAGS "-undefined dynamic_lookup")

      ADD_LIBRARY(StOptTree  SHARED  ${SOURCE_PYTHON}/Pybind11StOptTree.cpp)
      TARGET_LINK_LIBRARIES(StOptTree  ${STOPT_LIB}   ${GENERS_LIB} ${Boost_SERIALIZATION_LIBRARY}   ${Boost_MPI_LIBRARY} )
      SET_TARGET_PROPERTIES(StOptTree  PROPERTIES  PREFIX "" SUFFIX ${PYTHON_SUFFIX}  COMPILE_DEFINITIONS  "PYTHONMODULE;NPY_NO_DEPRECATED_API=NPY_1_7_API_VERSION" LINK_FLAGS "-undefined dynamic_lookup")

      ADD_LIBRARY(StOptGeners  SHARED  ${SOURCE_PYTHON}/Pybind11StOptGeners.cpp)
      TARGET_LINK_LIBRARIES(StOptGeners  ${STOPT_LIB}   ${GENERS_LIB} ${Boost_SERIALIZATION_LIBRARY}   ${Boost_MPI_LIBRARY})
      SET_TARGET_PROPERTIES(StOptGeners  PROPERTIES  PREFIX "" SUFFIX ${PYTHON_SUFFIX}  COMPILE_DEFINITIONS  "PYTHONMODULE;NPY_NO_DEPRECATED_API=NPY_1_7_API_VERSION" LINK_FLAGS "-undefined dynamic_lookup")

      ADD_LIBRARY(StOptGlobal  SHARED  ${SOURCE_PYTHON}/Pybind11StOptGlobal.cpp)
      TARGET_LINK_LIBRARIES(StOptGlobal  ${STOPT_LIB}   ${GENERS_LIB} ${Boost_SERIALIZATION_LIBRARY}   ${Boost_MPI_LIBRARY})
      SET_TARGET_PROPERTIES(StOptGlobal  PROPERTIES  PREFIX "" SUFFIX ${PYTHON_SUFFIX}  COMPILE_DEFINITIONS  "PYTHONMODULE;NPY_NO_DEPRECATED_API=NPY_1_7_API_VERSION" LINK_FLAGS "-undefined dynamic_lookup")

      ADD_LIBRARY(StOptCDF  SHARED  ${SOURCE_PYTHON}/Pybind11StOptCDF.cpp)
      TARGET_LINK_LIBRARIES(StOptCDF  ${STOPT_LIB}   ${GENERS_LIB} ${Boost_SERIALIZATION_LIBRARY}   ${Boost_MPI_LIBRARY})
      SET_TARGET_PROPERTIES(StOptCDF  PROPERTIES  PREFIX "" SUFFIX ${PYTHON_SUFFIX}  COMPILE_DEFINITIONS  "PYTHONMODULE;NPY_NO_DEPRECATED_API=NPY_1_7_API_VERSION" LINK_FLAGS "-undefined dynamic_lookup")
  
    ELSE()
      
      ADD_LIBRARY(StOptGrids  SHARED  ${SOURCE_PYTHON}/Pybind11StOptGrids.cpp)
      TARGET_LINK_LIBRARIES(StOptGrids  ${STOPT_LIB}   ${GENERS_LIB} ${Boost_SERIALIZATION_LIBRARY}   ${Boost_MPI_LIBRARY} ${Python_LIBRARIES})
      SET_TARGET_PROPERTIES(StOptGrids  PROPERTIES  PREFIX "" SUFFIX ${PYTHON_SUFFIX}  COMPILE_DEFINITIONS  "PYTHONMODULE;NPY_NO_DEPRECATED_API=NPY_1_7_API_VERSION")

      ADD_LIBRARY(StOptReg  SHARED  ${SOURCE_PYTHON}/Pybind11StOptReg.cpp)
      TARGET_LINK_LIBRARIES(StOptReg  ${STOPT_LIB}   ${GENERS_LIB} ${Boost_SERIALIZATION_LIBRARY}   ${Boost_MPI_LIBRARY} ${Python_LIBRARIES})
      SET_TARGET_PROPERTIES(StOptReg  PROPERTIES  PREFIX "" SUFFIX ${PYTHON_SUFFIX}  COMPILE_DEFINITIONS  "PYTHONMODULE;NPY_NO_DEPRECATED_API=NPY_1_7_API_VERSION")
