=== debian/changelog ===
stopt (5.12+dfsg-2build1) oracular; urgency=medium

  * No-change rebuild against mpi-defaults 1.17

 -- Erich Eickmeyer <eeickmeyer@ubuntu.com>  Thu, 01 Aug 2024 09:36:52 -0700

stopt (5.12+dfsg-2) unstable; urgency=medium

  * B-D on mpi-default-dev so that MPICH is chosen on 32-bit arches
  * Letting the --oversubscribe mpiexec flag be written by d/rules, as MPICH
    won't understand this

 -- Pierre Gruet <pgt@debian.org>  Thu, 25 Jul 2024 07:10:49 +0200

stopt (5.12+dfsg-1) unstable; urgency=medium

  * New upstream version 5.12+dfsg
  * Refreshing patches
  * Raising Standards version to 4.7.0 (no change)
  * Updating d/watch after the change in the layout of Gitlab
  * Removing redundant build-dependency on dpkg-dev

 -- Pierre Gruet <pgt@debian.org>  Wed, 24 Jul 2024 08:57:40 +0200
