## stopt 5.15+dfsg

=== debian/changelog ===
stopt (5.15+dfsg-1) experimental; urgency=medium

  * New upstream version 5.15+dfsg
  * Refreshing patches
  * Raising Standards version to 4.7.2 (no change)

 -- Pierre Gruet <pgt@debian.org>  Fri, 11 Jul 2025 15:20:24 +0200

stopt (5.12+dfsg-3) unstable; urgency=medium

  * Having the -dev package depend on mpi-default-dev so that MPICH is chosen
    on 32-bit arches (Closes: #1087962)
  * Skipping the build with mpi until stopt can be built with openmpi 5.x
    (Closes: #1086385)

 -- Pierre Gruet <pgt@debian.org>  Thu, 05 Dec 2024 09:39:41 +0100
