## stopt 5.16%2Bdfsg

=== debian/watch ===
version=4

opts="searchmode=plain,dversionmangle=s/\+dfsg\d*//,oversionmangle=s/(.*)/$1+dfsg/" \
  https://gitlab.com/stochastic-control/StOpt/tags?sort=updated_desc \
  -/archive/v?\d[\d.]+/StOpt-v@ANY_VERSION@\.tar\.gz debian

opts="component=texdoc,searchmode=plain" \
  https://gitlab.com/stochastic-control/StOptDoc/tags?sort=updated_desc \
  -/archive/v?\d[\d.]+/StOptDoc-v@ANY_VERSION@\.tar\.gz \
  ignore
