## stopt 5.16+dfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -49,7 +49,6 @@
 ENDIF(BUILD_LONG_TEST)
 
 # Boost
-ADD_DEFINITIONS(-DBOOST_ALL_DYN_LINK)
 IF(BUILD_TEST)
   FIND_PACKAGE(Boost COMPONENTS unit_test_framework  system  timer chrono log thread  REQUIRED)
 ENDIF()
@@ -117,7 +116,7 @@
   IF(MSVC_VERSION LESS 1800)
     MESSAGE(STATUS "The compiler ${CMAKE_CXX_COMPILER} has no decent C++11 support. Please use a different C++ compiler.")
   ENDIF()
-  ADD_COMPILE_OPTIONS(/bigobj)
+  ADD_COMPILE_OPTIONS(/bigobj /EHsc)
 ENDIF(NOT MSVC)
 
 # Update flags according to the compiler
