=== R/StOptRegression/DESCRIPTION ===
Package: StOptRegression
Type: Package
Title: What the Package Does in One 'Title Case' Line
Version: 1.0
Date: 2017-02-08
Author: Your Name
Maintainer: Your Name <your@email.com>
Description: One paragraph description of what the package does as one
        or more full sentences.
License: GPL (>= 2)
Imports: methods, Rcpp (>= 0.12.9)
LinkingTo: Rcpp, RcppEigen
RoxygenNote: 6.0.1
