=== debian/changelog ===
stopt (5.16+dfsg-2) unstable; urgency=medium

  * Deactivating part of a test which started failing with gcc-15
    (Closes: 1097940)

 -- Pierre Gruet <pgt@debian.org>  Sat, 06 Sep 2025 07:14:23 +0200

stopt (5.16+dfsg-1) unstable; urgency=medium

  * New upstream version 5.16+dfsg
  * Refreshing patches

 -- Pierre Gruet <pgt@debian.org>  Sun, 17 Aug 2025 19:15:18 +0200
