=== debian/rules ===
--- 
+++ 
@@ -38,9 +38,12 @@
 	-rm -rf texdocBuild/
 
 override_dh_auto_configure-arch:
+	# Skipping the build with mpi with BUILD_MPI=OFF until stopt can be built
+	# against openmpi 5.x
 	dh_auto_configure -- \
 	        -DCMAKE_LIBRARY_ARCHITECTURE="$(DEB_HOST_MULTIARCH)" \
 	        -DCMAKE_INSTALL_PREFIX="/usr" \
+	        -DBUILD_MPI=OFF \
 	        -DCMAKE_BUILD_RPATH_USE_ORIGIN=ON \
 	        -DSOVERSION_STOPT="$(SOVERSION_STOPT)" \
 	        -DVERSION_STOPT="$(VERSION_STOPT)" \
