=== debian/tests/control ===
Tests: someCppUnitTests
Depends: libstopt-dev, stopt-examples, g++
Restrictions: allow-stderr

Tests: pythonUnitTests
Depends: stopt-examples, python3-stopt, python3-numpy
