## stopt 6.1+dfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -86,8 +86,14 @@
 ENDIF(WIN32)
 
 #Eigen
-FIND_PACKAGE(Eigen3 REQUIRED)
+FIND_PACKAGE(Eigen3  3.4 REQUIRED )
 INCLUDE_DIRECTORIES(SYSTEM ${EIGEN3_INCLUDE_DIR})
+IF (EIGEN3_FOUND)
+  MESSAGE(STATUS "Eigen  ${EIGEN3_VERSION} found")
+ELSE()
+  MESSAGE(STATUS "Correct version of Eigen not found") 
+ENDIF(EIGEN3_FOUND)
+
 # Add some extra delete[] and new[] operatros needed by boost to Eigen::PlainObjectBase
 IF (APPLE)
   ADD_DEFINITIONS(-DEIGEN_PLAINOBJECTBASE_PLUGIN="StOpt/core/utils/eigenMemory.h")
@@ -209,7 +215,7 @@
 IF(BUILD_PYTHON)
     
   # Python
-  FIND_PACKAGE(Python REQUIRED COMPONENTS Interpreter Development NumPy)
+  FIND_PACKAGE(Python REQUIRED COMPONENTS Interpreter Development)
   INCLUDE_DIRECTORIES(SYSTEM ${Python_INCLUDE_DIRS})
   MESSAGE(STATUS "Python: ${Python_INCLUDE_DIRS}")
 
@@ -260,5 +266,3 @@
 
       ADD_LIBRARY(StOptReg  SHARED  ${SOURCE_PYTHON}/Pybind11StOptReg.cpp)
       TARGET_LINK_LIBRARIES(StOptReg  ${STOPT_LIB}   ${GENERS_LIB} ${Boost_SERIALIZATION_LIBRARY}   ${Boost_MPI_LIBRARY} ${Python_LIBRARIES})
-      SET_TARGET_PROPERTIES(StOptReg  PROPERTIES  PREFIX "" SUFFIX ${PYTHON_SUFFIX}  COMPILE_DEFINITIONS  "PYTHONMODULE;NPY_NO_DEPRECATED_API=NPY_1_7_API_VERSION")
-
