=== debian/changelog ===
stopt (6.1+dfsg-1) unstable; urgency=medium

  * New upstream version 6.1+dfsg
  * Refreshing patches
  * Bumping copyright years
  * Rewriting d/watch with version 5

 -- Pierre Gruet <pgt@debian.org>  Fri, 14 Nov 2025 13:10:51 +0100
