=== debian/control ===
--- 
+++ 
@@ -31,7 +31,7 @@
                      texlive-plain-generic <!nodoc>,
                      texlive-pstricks <!nodoc>,
                      texlive-science <!nodoc>
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Vcs-Browser: https://salsa.debian.org/math-team/stopt
 Vcs-Git: https://salsa.debian.org/math-team/stopt.git
 Homepage: https://gitlab.com/stochastic-control/StOpt/
@@ -95,7 +95,7 @@
          libboost-timer-dev,
          libeigen3-dev,
          libgeners-dev,
-         libopenmpi-dev,
+         mpi-default-dev,
          ${misc:Depends}
 Suggests: stopt-doc (= ${binary:Version})
 Description: library for stochastic optimization problems (development package)
