=== debian/watch ===
Version: 5

Source: https://gitlab.com/stochastic-control/StOpt/tags?sort=updated_desc
Matching-Pattern: -/archive/v?\d[\d.]+/StOpt-v@ANY_VERSION@\.tar\.gz
Dversionmangle: s/\+dfsg\d*//
Oversionmangle: s/(.*)/$1+dfsg/
Searchmode: plain

Component: texdoc
Source: https://gitlab.com/stochastic-control/StOptDoc/tags?sort=updated_desc
Matching-Pattern: -/archive/v?\d[\d.]+/StOptDoc-v@ANY_VERSION@\.tar\.gz
Searchmode: plain
Version-Schema: ignore
